/* Shopper
 * Copyright (C) 2008 David Greaves
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */

#include "shopperList.h"
#include <QtGui>
#include "LabelEntry.h"

namespace Shopper
{
	// private helper class
	class CatView : public QWidget
	{
		Q_OBJECT;
	public:
		CatView(Category &it, List &l,QWidget * parent = 0) ;

		Category* get_cat();
		void set_pos(int, int);
//		virtual void setVisible(bool vis);

	public slots:
		void name_changed();
		void delete_category();
		
	signals:
		void move_up();
		void move_down();

	private:
		LabelEntry *name;		
		// UI
		QToolButton *up_b;
		QToolButton *down_b;
		
		// member data
		Category       *mycat;
		List           *mylist;
	};
	
// private base for adding/editing an Category
	class CategoryDialog : public QDialog
	{
		Q_OBJECT;
	protected:
		CategoryDialog(QWidget * parent, Shopper::List*, Shopper::Category*);
		
	public slots:
		void update_area();
		void add_category();
		void move_up();
		void move_down();

	private:
		void move(Shopper::CatView *c, int direction);

		// Data
		Shopper::List               *mylist;
		Shopper::Category           *mycat;

		// UI
		QVBoxLayout        *vbox;
		QDialogButtonBox   *bbox;
		QPushButton        *doneB;
		QPushButton        *addB;
		
		QScrollArea        *areaS;
		QVBoxLayout        *areaL;
		QWidget            *area;
		
	};

// Public classes for managing
class CategoryManage : public CategoryDialog
	{
	public:
		CategoryManage(QWidget * parent, Shopper::List* mylist);
	};
}
